!+
! Module: array_utils
!
! Authors:  Ian Stewart - SSC/LUX
!          
! Description: Contains routines to manipulate vectors and arrays.
! 
! Comments: TODO:
!
! $Id: module.f90,v 1.6 1998/05/27 13:45:39 gvacanti Exp $
!- 
module array_utils

  use dal
!***** want to translate it to non-dal forms.

  implicit none 

  private 

  public selectImageSubset

  interface selectImageSubset
    module procedure selectImageSubsetInt8
    module procedure selectImageSubsetSingle
    module procedure selectImageSubsetBool
  end interface

contains 

  !---------------------------------------------------------------------
  subroutine selectImageSubsetInt8(image, xStart, xFinis, yStart, yFinis)
  !---------------------------------------------------------------------

    implicit none

    integer(int8), pointer :: image(:,:)
    integer(int16), intent(in) :: xStart, xFinis, yStart, yFinis

    integer(int8), pointer :: tempSingleArray(:,:)

    !-------------------------------------------------------------------
    ! Start

    allocate(tempSingleArray(xStart:xFinis, yStart:yFinis))
    tempSingleArray = image(xStart:xFinis, yStart:yFinis)
    deallocate(image)
    allocate(image(xStart:xFinis, yStart:yFinis))
    image => tempSingleArray

    ! NOTE! We should NOT deallocate tempSingleArray now or ever, because
    ! it is pointing to the same area of memory as image. When we want to
    ! clear this memory, it suffices to deallocate(image).

  end subroutine selectImageSubsetInt8

  !---------------------------------------------------------------------
  subroutine selectImageSubsetSingle(image, xStart, xFinis, yStart, yFinis)
  !---------------------------------------------------------------------

    implicit none

    real(single), pointer :: image(:,:)
    integer(int16), intent(in) :: xStart, xFinis, yStart, yFinis

    real(single), pointer :: tempSingleArray(:,:)

    !-------------------------------------------------------------------
    ! Start

    allocate(tempSingleArray(xStart:xFinis, yStart:yFinis))
    tempSingleArray = image(xStart:xFinis, yStart:yFinis)
    deallocate(image)
    allocate(image(xStart:xFinis, yStart:yFinis))
    image => tempSingleArray

    ! NOTE! We should NOT deallocate tempSingleArray now or ever, because
    ! it is pointing to the same area of memory as image. When we want to
    ! clear this memory, it suffices to deallocate(image).

  end subroutine selectImageSubsetSingle

  !---------------------------------------------------------------------
  subroutine selectImageSubsetBool(image, xStart, xFinis, yStart, yFinis)
  !---------------------------------------------------------------------

    implicit none
    logical, pointer :: image(:,:)
    integer(int16), intent(in) :: xStart, xFinis, yStart, yFinis

    logical, pointer :: tempSingleArray(:,:)

    !-------------------------------------------------------------------
    ! Start

    allocate(tempSingleArray(xStart:xFinis, yStart:yFinis))
    tempSingleArray = image(xStart:xFinis, yStart:yFinis)
    deallocate(image)
    allocate(image(xStart:xFinis, yStart:yFinis))
    image => tempSingleArray

    ! NOTE! We should NOT deallocate tempSingleArray now or ever, because
    ! it is pointing to the same area of memory as image. When we want to
    ! clear this memory, it suffices to deallocate(image).

  end subroutine selectImageSubsetBool

  !---------------------------------------------------------------------
  subroutine template
  !---------------------------------------------------------------------

    implicit none

    !-------------------------------------------------------------------
    ! Start

  end subroutine template

end module array_utils
